﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Statki.Model
{
    public class AddRandomShip
    {
        public List<Field> AllFields { get; private set; }
        public List<Field> RandShip { get; private set; }
        private Field[,] fields;
        private Random rand;
        private int x;
        private int y;
        Direction direction;
        

        public AddRandomShip(Field[,] fields)
        {
            AllFields = new List<Field>();
            RandShip = new List<Field>();
            this.fields = fields;
            foreach(Field field in fields)
            {
                AllFields.Add(field);
            }
            rand = new Random();
        }
        private Direction CalculateDirection()
        {
            int direction = rand.Next(0, 2);
            return direction == 0 ? Direction.Horizontal : Direction.Vertical;
        }
        public List<Field> RandCoordinates(int actualShipAddSize)
        {
            var occupiedFields = AllFields.Where(field => field.Ship != null).Select(field => field.Ship).Distinct().SelectMany(ship => ship.GetOccupietFields(fields)).Distinct().ToList();
            direction = CalculateDirection();
            List<Field> tmpFields = new List<Field>();
            int i = 0;
            int offx = direction == Direction.Horizontal ? actualShipAddSize : 0;
            int offy = direction == Direction.Horizontal ? 0 : actualShipAddSize;
            while (i < actualShipAddSize)
            {
                
                x = rand.Next(1, fields.GetLength(0) - offx);
                y = rand.Next(1, fields.GetLength(1) - offy);

                for (int j = 0; j < actualShipAddSize; j++)
                {
                    if (direction == Direction.Horizontal)
                    {
                        x++;
                    }
                    else
                    {
                        y++;
                    }
                    if(occupiedFields.Any(field => field.Coordinate.X == x && field.Coordinate.Y == y))
                    {
                        i = 0;
                        tmpFields.Clear();
                        direction = CalculateDirection();
                        offx = direction == Direction.Horizontal ? actualShipAddSize : 0;
                        offy = direction == Direction.Horizontal ? 0 : actualShipAddSize;
                        break;
                    }
                    i++;
                    tmpFields.Add(AllFields.Find(f => f.Coordinate.X == x && f.Coordinate.Y == y));
                }
            }


            return tmpFields;


        }
        public List<Field> CreateRandShip(int boardDimension, int actualShipAdd)
        {
            
            direction = CalculateDirection();

            if (direction == Direction.Horizontal)
            {
                x = rand.Next(0, boardDimension - actualShipAdd);
                y = rand.Next(0, boardDimension);
                for(int i = 0; i < actualShipAdd; i++)
                {
                    Field field = AllFields.Find(f => f.Coordinate.X + i == x + i && f.Coordinate.Y == y);
                    RandShip.Add(field);
                }
            }
            else
            {
                y = rand.Next(0, boardDimension - actualShipAdd);
                x = rand.Next(0, boardDimension);

                for (int i = 0; i < actualShipAdd; i++)
                {
                    Field field = AllFields.Find(f => f.Coordinate.X == x && f.Coordinate.Y + i == y + i);
                    RandShip.Add(field);
                }
            }
            return RandShip;
            
        }
    }
}
